Bug 1086478 - openssh: RAND_load_file("/dev/urandom") isn't allowed in OpenSSL 1.1.1
openssh: RAND_load_file("/dev/urandom") isn't allowed in OpenSSL 1.1.1
Status: RESOLVED FIXED
Classification: openSUSE
Product: openSUSE Tumbleweed
Classification: openSUSE
Component: Basesystem
Current
Other Other
: P5 - None : Normal (vote)
: ---
Assigned To: Petr Cerny
E-mail List
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2018-03-22 13:50 UTC by Vítězslav Čížek
Modified: 2018-03-28 14:23 UTC (History)
3 users (show)

See Also:
Found By: ---
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Vítězslav Čížek 2018-03-22 13:50:59 UTC
Our openssh doesn't currently work with the upcoming openssl 1.1.1.

> ssh localhost
EOF reading /dev/urandom

In linux_seed(), openssh uses RAND_load_file() in attempt to read random data from /dev/urandom. This code comes from our openssh-7.6p1-seed-prng.patch.
However, since https://github.com/openssl/openssl/commit/9ee344f5cd5e935c60d3bf7c3ce9ee21895069db, RAND_load_file() allows reading only from regular files, not special devices.

There's an openssl github issue, where this is being discussed:
https://github.com/openssl/openssl/issues/5511
Comment 1 Petr Cerny 2018-03-22 23:38:59 UTC
SLE-15 will have 1.1.0 or 1.1.1?
Comment 3 Vítězslav Čížek 2018-03-23 10:00:00 UTC
It looks like openssl might allow reading from devices after all.

There's a pull request (https://github.com/openssl/openssl/pull/5728) to add a similar code back to retain compatibility.
Comment 4 Vítězslav Čížek 2018-03-28 14:23:30 UTC
Fixed in openssl git master (https://github.com/openssl/openssl/commit/242fcd695db6225ef98c5ad084e6f15ec5953158)
OpenSSH will work again with the next 1.1.1 release.